Phpactor
========

![phpactor2sm](https://user-images.githubusercontent.com/530801/27995098-82e72c4c-64c0-11e7-96d2-f549c711ca8b.png)

| Branch       | Status                                                                                                                         |
| ------------ | ------------------------------------------------------------------------------------------------------------------------------ |
| master       | [![Build Status: master](https://travis-ci.org/phpactor/phpactor.svg?branch=master)](https://travis-ci.org/phpactor/phpactor)  |
| develop      | [![Build Status: develop](https://travis-ci.org/phpactor/phpactor.svg?branch=develop)](https://travis-ci.org/phpactor/phpactor) |

This project aims to provide heavy-lifting *refactoring* and *introspection*
tools which can be used standalone or as the backend for a text editor to
provide intelligent code completion.

- Accurate code [completion](https://phpactor.readthedocs.io/en/develop/reference/completion.html) including class name auto-import.
- [Various](https://phpactor.readthedocs.io/en/develop/reference/refactorings.html) refactoring,fixes and code generation options.
- Provides a [Language Server](https://phpactor.readthedocs.io/en/develop/usage/language-server.html)
- Native [VIM plugin](https://phpactor.readthedocs.io/en/develop/usage/vim-plugin.html) ([emacs](https://github.com/emacs-php/phpactor.el) plugin is in development).
- [Navigation](https://phpactor.readthedocs.io/en/develop/reference/navigation.html) (jump to
  definition, related classes, references etc).
- [More](https://phpactor.readthedocs.io/en/develop).

Installation
------------

Phpactor is a general tool, it is not intended that it be installed as a project dependency.

See
[Installation](https://phpactor.readthedocs.io/en/develop/usage/standalone.html)
for installation instructions.

Requirements
------------

- PHP 7.1+
- Composer

Project Recommendations
-----------------------

Phpactor will perform better with [Composer](https://getcomposer.org) and, to
a lesser extent, with [GiT](https://git-scm.org).

Documentation
-------------

Full documentation can be found on [Read the Docs](https://phpactor.readthedocs.io/en/develop)

Community
---------

- Follow [@phpactor](https://twitter.com/phpactor) for the latest news.
- Join the `#phpactor` channel on the Slack [Symfony Devs](https://symfony.com/slack-invite) channel.
